/**
 * @param {PropertyKey[]} methods 
 * @param {Fn} f
 */
export function dispatch(methods, f) {
  return function() {
    if (arguments.length === 0) {
      return f()
    }

    const args = Array.from(arguments)
    const obj = last(args)

    if (!isArray(obj)) {
      for (let i = 0; i < obj.length; i++) {
        const fn = obj[methods[i]]
        if (isFn(fn)) {
          return fn.apply(obj, args.slice(0, -1))
        }
      }
    }

    return f.apply(this, arguments)
  }
}

